package valeurs;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;

public class ValeursImplTest {

	Valeurs v;

	@Before
	public void setUp() throws Exception {
		v = new ValeursImpl(1., 2., 3.);
	}

	@Test(expected = ValeurNegativeException.class)
	public void testValeursImpl() throws ValeurNegativeException {
		Valeurs v2 = new ValeursImpl(1., -2., 3.);
	}

	@Test
	public void testValeur() {
		// Pour les doubles, assertEquals(x, y) est obsolète 
		// (deprecated). Il faut à la place utiliser 
		// assertEquals(x, y, precision) qui compare x et y avec 
		// une précision donnée
		assertEquals(v.valeur(0), 1.0, 0.);
	}

	@Test
	public void testChangerValeur1() throws ValeurNegativeException {
		v.changerValeur(1, 5.);
		assertEquals(v.valeur(1), 5.0, 0.);
	}

	@Test(expected = ValeurNegativeException.class)
	public void testChangerValeur2() throws ValeurNegativeException {
		v.changerValeur(1, -5.);
	}
	
	@Test
	public void testTaille() {
		assertEquals(v.taille(), 3);
	}

	@Test
	public void testSomme() throws ValeurNegativeException {
		Valeurs v2 = new ValeursImpl(1., 2., 3.);
		assertEquals(v2.somme(), 6., 0.);
		v2.changerValeur(1, 5.);
		assertEquals(v2.somme(), 9., 0.);		
	}

}
